//
// TimeServiceServerHelper.cpp
//
// Package: Generated
// Module:  TimeServiceServerHelper
//
// This file has been generated.
// Warning: All changes to this will be lost when the file is re-generated.
//
// Copyright (c) 2006-2012, Applied Informatics Software Engineering GmbH.
//


#include "TimeServiceServerHelper.h"
#include "Poco/RemotingNG/URIUtility.h"
#include "TimeServiceEventDispatcher.h"
#include "TimeServiceSkeleton.h"


namespace Services {


TimeServiceServerHelper::TimeServiceServerHelper():
	_pORB(0)
{
	_pORB = &Poco::RemotingNG::ORB::instance();
	_pORB->registerSkeleton("TimeService", new TimeServiceSkeleton);
}


TimeServiceServerHelper::~TimeServiceServerHelper()
{
	_pORB->unregisterSkeleton("TimeService", true);
}


std::string TimeServiceServerHelper::registerRemoteObject(Poco::AutoPtr<Services::TimeServiceRemoteObject> pRemoteObject, const std::string& listenerId)
{
	return TimeServiceServerHelper::instance().registerObjectImpl(pRemoteObject, listenerId);
}


void TimeServiceServerHelper::enableEventsImpl(const std::string& uri, const std::string& protocol)
{
	Poco::RemotingNG::Identifiable::Ptr pIdentifiable = _pORB->findObject(uri);
	Poco::AutoPtr<TimeServiceRemoteObject> pRemoteObject = pIdentifiable.cast<TimeServiceRemoteObject>();
	if (pRemoteObject)
	{
		Poco::RemotingNG::EventDispatcher::Ptr pEventDispatcher = new TimeServiceEventDispatcher(pRemoteObject, protocol);
		_pORB->registerEventDispatcher(uri, pEventDispatcher);
	}
	else throw Poco::NotFoundException("remote object", uri);
}


TimeServiceServerHelper& TimeServiceServerHelper::instance()
{
	static TimeServiceServerHelper r;
	return r;
}


std::string TimeServiceServerHelper::registerObjectImpl(Poco::AutoPtr<Services::TimeServiceRemoteObject> pRemoteObject, const std::string& listenerId)
{
	return _pORB->registerObject(pRemoteObject, listenerId);
}


void TimeServiceServerHelper::unregisterObjectImpl(const std::string& uri)
{
	_pORB->unregisterObject(uri);
}


} // namespace Services

