//
// DimmingServerHelper.h
//
// Library: LightingControls1
// Package: Generated
// Module:  DimmingServerHelper
//
// This file has been generated.
// Warning: All changes to this will be lost when the file is re-generated.
//
// Copyright (c) 2011-2012, Applied Informatics Software Engineering GmbH.
// All rights reserved.
// 
// This is unpublished proprietary source code of Applied Informatics.
// The contents of this file may not be disclosed to third parties,
// copied or duplicated in any form, in whole or in part.
// 
//


#ifndef LightingControls1_DimmingServerHelper_INCLUDED
#define LightingControls1_DimmingServerHelper_INCLUDED


#include "Poco/RemotingNG/Identifiable.h"
#include "Poco/RemotingNG/ORB.h"
#include "UPnPS/LightingControls1/Dimming.h"
#include "UPnPS/LightingControls1/DimmingRemoteObject.h"
#include "UPnPS/LightingControls1/IDimming.h"
#include "UPnPS/LightingControls1/LightingControls1.h"


namespace UPnPS {
namespace LightingControls1 {


class LightingControls1_API DimmingServerHelper
{
public:
private:
	DimmingServerHelper();
		/// Creates a DimmingServerHelper.

	~DimmingServerHelper();
		/// Destroys the DimmingServerHelper.

public:
	static void enableEvents(const std::string& uri, const std::string& protocol);
		/// Enables remote events for the RemoteObject identified by the given URI.
		///
		/// Events will be delivered using the Transport for the given protocol.
		/// Can be called multiple times for the same URI with different protocols.

	static std::string registerObject(Poco::SharedPtr<UPnPS::LightingControls1::Dimming> pServiceObject, const Poco::RemotingNG::Identifiable::ObjectId& oid, const std::string& listenerId);
		/// Creates a RemoteObject wrapper for the given UPnPS::LightingControls1::Dimming instance
		/// and registers it with the ORB and the Listener instance
		/// uniquely identified by the Listener's ID.
		/// 
		///	Returns the URI created for the object.

	static std::string registerRemoteObject(Poco::AutoPtr<UPnPS::LightingControls1::DimmingRemoteObject> pRemoteObject, const std::string& listenerId);
		/// Registers the given RemoteObject with the ORB and the Listener instance
		/// uniquely identified by the Listener's ID.
		/// 
		///	Returns the URI created for the object.

	static void unregisterObject(const std::string& uri);
		/// Unregisters a service object identified by URI from the ORB.

private:
	void enableEventsImpl(const std::string& uri, const std::string& protocol);

	static DimmingServerHelper& instance();
		/// Returns a static instance of the helper class.

	std::string registerObjectImpl(Poco::AutoPtr<UPnPS::LightingControls1::DimmingRemoteObject> pRemoteObject, const std::string& listenerId);

	void unregisterObjectImpl(const std::string& uri);

	Poco::RemotingNG::ORB* _pORB;
};


inline void DimmingServerHelper::enableEvents(const std::string& uri, const std::string& protocol)
{
	DimmingServerHelper::instance().enableEventsImpl(uri, protocol);
}


inline std::string DimmingServerHelper::registerObject(Poco::SharedPtr<UPnPS::LightingControls1::Dimming> pServiceObject, const Poco::RemotingNG::Identifiable::ObjectId& oid, const std::string& listenerId)
{
	return DimmingServerHelper::instance().registerObjectImpl(new DimmingRemoteObject(oid, pServiceObject), listenerId);
}


inline void DimmingServerHelper::unregisterObject(const std::string& uri)
{
	DimmingServerHelper::instance().unregisterObjectImpl(uri);
}


} // namespace LightingControls1
} // namespace UPnPS


#endif // LightingControls1_DimmingServerHelper_INCLUDED

